
Redmine - Defect #33769

When creating more than two identical attachments in a single db transaction, the first one always

ends up unreadable

2020-07-26 10:23 - Jens Krämer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 4.0.8   

Resolution: Fixed Affected version:  

Description

Due to the file re-using code running in an after_commit hook, the hooks of any attachments that are created in a common db

transaction will be deferred and run one after another after the outer transaction was committed. The existing implementation does

not take that into account and as a consequence, when creating more than two identical attachments in a single transaction, the first

attachment will end up with a non-existing diskfile.

The attached patch includes a test reproducing the issue and a fix, which consists of using last instead of first when finding an

existing attachment to re-use. This way, the selected attachment is consistent across all runs of the hook even if multiple candidates

exist. I also added an explicit order call for good measure.

This is a corner case that should never occur in normal Redmine usage - but may occur in 3rd party code that's creating many

attachments wrapped in a transaction.

Related issues:

Has duplicate Redmine - Defect #28440: After commit missing file Closed

Associated revisions

Revision 20094 - 2020-09-28 16:25 - Go MAEDA

When creating more than two identical attachments in a single transaction, the first one always ends up unreadable (#33769).

Patch by Jens Krämer.

Revision 20095 - 2020-09-30 15:46 - Go MAEDA

Merged r20094 from trunk to 4.1-stable (#33769).

Revision 20096 - 2020-09-30 15:57 - Go MAEDA

Merged r20094 from trunk to 4.0-stable (#33769).

History

#1 - 2020-09-28 15:16 - Go MAEDA

- Target version set to 4.0.8

Setting the target version to 4.0.8.

#2 - 2020-09-28 15:49 - Go MAEDA

- Has duplicate Defect #28440: After commit missing file added

#3 - 2020-09-28 16:26 - Go MAEDA

- Tracker changed from Patch to Defect

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix. Thank you for your contribution.
#4 - 2020-09-30 15:58 - Go MAEDA

- Status changed from Resolved to Closed

Files

0001-fix-creation-of-multiple-identical-attachments-in-ou.patch 1.96 KB 2020-07-26 Jens Krämer
